#ifndef ___HGL___PROXY_PTR___
#define ___HGL___PROXY_PTR___

/**
 * @brief 必要な時にだけ生成するようなポインタ。
 */
template<class T>
class proxy_ptr {
public:

	proxy_ptr() : m_pObj(NULL) {}
	~proxy_ptr() {
		if (m_pObj != NULL) {
			delete m_pObj;
		}
	}

	//ポインタの代わりをするための機能。
	T* operator->() {checkInstance();return m_pObj;}
	T& operator*() { checkInstance();return *m_pObj;}
	const T* operator->() const {checkInstance();return m_pObj;}
	const T& operator*() const {checkInstance(); return *m_pObj;}

	operator T*() {checkInstance();return m_pObj;}

private:

	void checkInstance() const {
		proxy_ptr<T>* p = const_cast<proxy_ptr<T>*>(this);
		if (p->m_pObj == NULL) {
			p->m_pObj = new T;
		}
	}

	T* m_pObj;

};

#endif