#ifndef _UTAKATA_SRC_BASE_OBJECT_H_
#define _UTAKATA_SRC_BASE_OBJECT_H_

#include "src/common/smart_ptr.h"

namespace utakata {

    namespace data {
        class DataEntity;
    };

    namespace interpreter {

        class IClass;
        class IObject {
            // scheme中の実体オブジェクトのベースとなるインターフェース。
            // 実体としては、単純にClassの情報のみを持つことになる。
        public:
            IObject() {}
            virtual ~IObject() {}

            virtual smart_ptr<IClass> getClass() = 0;
        };
    };
};

#endif /* #define _UTAKATA_SRC_BASE_OBJECT_H__ */
