#ifndef _UTAKATA_SRC_COMMON_DISABLE_COPY_H_
#define _UTAKATA_SRC_COMMON_DISABLE_COPY_H_

namespace utility {

// 継承したクラスで、コピー不可であることを明示するためのインターフェース。
// コピー不可であることを明示する以外に利用方法は無い。
// また、このクラスはprivate継承を用いて継承するべきである。
class DisableCopyInterface {
 public:
  DisableCopyInterface() {}
  virtual ~DisableCopyInterface() {}

 private:

  DisableCopy(const DisableCopy& c);
  DisableCopy& operator=(const DisableCopy& c);
};
};  // end of namespace utility

#endif /* _UTAKATA_SRC_COMMON_DISABLE_COPY_H_ */
