#ifndef _DATA_CASTOR_H_
#define _DATA_CASTOR_H_

#include <string>

namespace utakata {

namespace data {

template<typename T>
class DataCastor {
  // 各データ実体へのキャストを行うためのインターフェース。こ
  // の関数オブジェクトを利用している限り、DataEntityのインター
  // フェースがどうなっているかを気にする必要は無い。
 public:
  DataCastor() {}
  virtual ~DataCastor() {}

  T* operator()(const data::Object& p) {
    return reinterpret_cast<T*>(
        p.getSpace()->getTypeDescripter().
        getEntity()->getAddress());
  }
};
};
};

#endif /* _DATA_CASTOR_H_ */
