#include "data_structure.h"
#include "type.h"

using namespace utakata::data;
using namespace utakata;

DataSpace::DataSpace(const smart_ptr<type::TypeDescripter>& data) :
    space_(data)
{}

DataSpace::DataSpace(const DataSpace& space)
{
    swap(space);
}

DataSpace& DataSpace::operator=(const DataSpace& space)
{
    DataSpace tmp(space);
    swap(tmp);
    return *this;
}

void DataSpace::swap(const DataSpace& space)
{
    // 指す領域を交換する。
    space_ = space.space_;
}

type::TypeDescripter& DataSpace::getTypeDescripter()
{
    return *space_;
}

bool DataSpace::operator==(const DataSpace& space)
{
    // 現在保持しているTypeDescripterのspace_が同じ場所を
    // 指しているかどうかを返す。

    return space_ == space.space_;
}

bool DataSpace::operator!=(const DataSpace& space)
{
    return !(space_ == space.space_);
}

