#ifndef _INTERPRETER_H_
#define _INTERPRETER_H_

namespace utakata {

    namespace intepreter {
    
        class Interpreter
        {
            // 実際にparserから読出したdatumをprogram statementとして解釈
            // して実行する。
            // 内部では、read-eval-print-loop(REPL)が動作しており、末尾
            // に至るまで繰り返す。
            // 内部で実行されるevalなどは、実際には外部に存在するものを利用する
            // のみとなっている。
            // 環境などの管理は、すべてinterpreter上でのみ行われる。
            // 現在の環境は、interpreterの内部で保持しているEnvironmentを
            // トップ環境として、それぞれコンテキストが変化する度に新規のEnvironment
            // に一つ上の環境がくっつく形を取る。
            // 利用する上では、parserの制限上、istreamを入力として取る。
            // また、interpreter内部では、プログラム全体を処理するためのフェーズ管理までを行う。
            // ライブラリに関しては、その管理を専門に行う処理が別に存在している。
        public:
            Interpreter();
            virtual ~Interpreter();
        };
    
    };

};

#endif /* _INTERPRETER_H_ */
