#ifndef _PARSER_STATUS_H_
#define _PARSER_STATUS_H_

namespace utakata {
    namespace parser {
        enum PARSERSTATUS {
            PS_INIT                = 0,  /* 初期時点 */
            PS_DATUM               = 1,  /* detumであるかどうか */
            PS_LEXEME_DATUM        = 2,  /* lexeme_detumのどれかであるか */
            PS_LIST                = 4,  /* リストdatumの処理。*/
            PS_ABBREVIATION        = 7,  // abbrev syntaxの後。
            PS_VECTOR_START        = 15, /* #( */
            PS_VECTOR_END          = 16, /* #(と対応した) */
            PS_BYTEVECTOR_START    = 17, /* #vu8( */
            PS_BYTEVECTOR_END      = 18, /* #vu8(と対応した) */
            PS_ERROR,                    // 構文異常が発生した場合に設定される。
                                         // これが設定されている場合、lexmの読み出しは進まず、
                                         // その時点で終了することになる。
            PS_END_DOT,                 // listの終了時点を表す。)以外は許容されない。
        };
    };
};

#endif /* _PARSER_STATUS_H_ */
