#include <string>
#include <iostream>
#include <sstream>

#include "../simpletest.h"
#include "../textarrayformat.h"
#include "../smart_function_callback.h"

using namespace std;

bool taf_test(smart_ptr<simpletest::SimpleTestAsserter> asserter)
{
    std::stringstream ss;

    ss << "=====" << std::endl;
    ss << "test" << std::endl << "test" << std::endl;
    ss << "=====" << endl;
    ss << "testhoge" << endl;
    ss << "=====" << endl;
    ss << "test\ntest" << endl;
    
    textarrayformat::TextArrayReader reader(ss);
    asserter->check(reader.get(), "test\ntest\n");
    asserter->check(reader.get(1), "testhoge\n");
    asserter->check(reader.get(0), "test\ntest\n");
    asserter->check(reader.get(2), "test\ntest\n");

    return asserter->isOk();
}

int main(int argc, char *argv[])
{
    simpletest::SimpleTestSuite suite("textarrayformat");
    suite.addTester(sfcr::screate(taf_test, suite.getAsserter()));
    return suite.run();
}
