#ifndef _TRANSCODER_H_
#define _TRANSCODER_H_

#include <iostream>
#include <vector>

namespace utakata {

    namespace transcoder {

        class ITranscoder
        {
            // 入力されたバイト列を、それぞれの判定によってUniCharに
            // 変換する。
            // このインターフェースは入力値を変換するためだけのものであり、
            // schemeのtranscoderとは多少機能が異なる。
            // これはlexerのインターフェースで利用される。
        public:
            ITranscoder() {}
            virtual ~ITranscoder() {}

            // 渡されたInputPortから一文字分だけ読み出して、unicode値を返す。
            virtual unsigned long encode(std::istream& bytes) = 0;
            // 渡されたcodeに対応する、自身のエンコードとなるバイト列を返す。
            virtual std::vector<int> decode(unsigned long code) = 0;
        };
    };

};

#endif /* _TRANSCODER_H_ */
